<?php /*

 Composr
 Copyright (c) ocProducts, 2004-2016

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  ocProducts Ltd
 * @package    cns_thematic_avatars
 */

/**
 * Hook class.
 */
class Hook_addon_registry_cns_thematic_avatars
{
    /**
     * Get a list of file permissions to set
     *
     * @param  boolean $runtime Whether to include wildcards represented runtime-created chmoddable files
     * @return array File permissions to set
     */
    public function get_chmod_array($runtime = false)
    {
        return array();
    }

    /**
     * Get the version of Composr this addon is for
     *
     * @return float Version number
     */
    public function get_version()
    {
        return cms_version_number();
    }

    /**
     * Get the description of the addon
     *
     * @return string Description of the addon
     */
    public function get_description()
    {
        return 'A selection of avatars for Conversr';
    }

    /**
     * Get a list of tutorials that apply to this addon
     *
     * @return array List of tutorials
     */
    public function get_applicable_tutorials()
    {
        return array(
            'tut_members',
        );
    }

    /**
     * Get a mapping of dependency types
     *
     * @return array File permissions to set
     */
    public function get_dependencies()
    {
        return array(
            'requires' => array(
                'cns_member_avatars',
            ),
            'recommends' => array(),
            'conflicts_with' => array(),
        );
    }

    /**
     * Explicitly say which icon should be used
     *
     * @return URLPATH Icon
     */
    public function get_default_icon()
    {
        return 'themes/default/images/icons/48x48/menu/_generic_admin/component.png';
    }

    /**
     * Get a list of files that belong to this addon
     *
     * @return array List of files
     */
    public function get_file_list()
    {
        return array(
            'sources/hooks/systems/addon_registry/cns_thematic_avatars.php',
            'themes/default/images/cns_default_avatars/default_set/thematic/animals.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/books.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/business.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/chess.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/food.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/games.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/index.html',
            'themes/default/images/cns_default_avatars/default_set/thematic/money.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/music.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/nature.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/outdoors.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/space.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/sports.png',
            'themes/default/images/cns_default_avatars/default_set/thematic/tech.png',
        );
    }
}
