<?php /*

 Composr
 Copyright (c) ocProducts, 2004-2016

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  ocProducts Ltd
 * @package    core_graphic_text
 */

/**
 * Hook class.
 */
class Hook_addon_registry_core_graphic_text
{
    /**
     * Get a list of file permissions to set
     *
     * @param  boolean $runtime Whether to include wildcards represented runtime-created chmoddable files
     * @return array File permissions to set
     */
    public function get_chmod_array($runtime = false)
    {
        return array();
    }

    /**
     * Get the version of Composr this addon is for
     *
     * @return float Version number
     */
    public function get_version()
    {
        return cms_version_number();
    }

    /**
     * Get the description of the addon
     *
     * @return string Description of the addon
     */
    public function get_description()
    {
        return 'Core rendering functionality for imagery.';
    }

    /**
     * Get a list of tutorials that apply to this addon
     *
     * @return array List of tutorials
     */
    public function get_applicable_tutorials()
    {
        return array(
            'tut_fringe',
        );
    }

    /**
     * Get a mapping of dependency types
     *
     * @return array File permissions to set
     */
    public function get_dependencies()
    {
        return array(
            'requires' => array(),
            'recommends' => array(),
            'conflicts_with' => array(),
        );
    }

    /**
     * Explicitly say which icon should be used
     *
     * @return URLPATH Icon
     */
    public function get_default_icon()
    {
        return 'themes/default/images/icons/48x48/menu/_generic_admin/component.png';
    }

    /**
     * Get a list of files that belong to this addon
     *
     * @return array List of files
     */
    public function get_file_list()
    {
        return array(
            'sources/hooks/systems/addon_registry/core_graphic_text.php',
            'sources/fonts.php',
            'themes/default/css/fonts.css',
            'data/fonts/FreeMono.ttf',
            'data/fonts/FreeMonoBold.ttf',
            'data/fonts/FreeMonoBoldOblique.ttf',
            'data/fonts/FreeMonoOblique.ttf',
            'data/fonts/FreeSans.ttf',
            'data/fonts/FreeSansBold.ttf',
            'data/fonts/FreeSansBoldOblique.ttf',
            'data/fonts/FreeSansOblique.ttf',
            'data/fonts/FreeSerif.ttf',
            'data/fonts/FreeSerifBold.ttf',
            'data/fonts/FreeSerifBoldItalic.ttf',
            'data/fonts/FreeSerifItalic.ttf',
            'data/fonts/index.html',
            'data/gd_text.php',
            'data_custom/fonts/index.html',
        );
    }
}
