<?php /*

 Composr
 Copyright (c) ocProducts, 2004-2016

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  ocProducts Ltd
 * @package    ecommerce
 */

/**
 * Hook class.
 */
class Hook_config_max_ip_addresses_per_subscriber
{
    /**
     * Gets the details relating to the config option.
     *
     * @return ?array The details (null: disabled)
     */
    public function get_details()
    {
        return array(
            'human_name' => 'MAX_IP_ADDRESSES_PER_SUBSCRIBER',
            'type' => 'integer',
            'category' => 'SECURITY',
            'group' => 'ECOMMERCE',
            'explanation' => 'CONFIG_OPTION_max_ip_addresses_per_subscriber',
            'shared_hosting_restricted' => '0',
            'list_options' => '',

            'addon' => 'ecommerce',
        );
    }

    /**
     * Gets the default value for the config option.
     *
     * @return ?string The default value (null: option is disabled)
     */
    public function get_default()
    {
        if (get_forum_type() != 'cns') {
            return null;
        }
        if (!addon_installed('stats')) {
            return null;
        }
        if (is_cns_satellite_site()) {
            return null;
        }
        if (!db_has_subqueries($GLOBALS['SITE_DB']->connection_write)) {
            return null;
        }

        return '';
    }
}
