<?php /*

 Composr
 Copyright (c) ocProducts, 2004-2016

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license    http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright  ocProducts Ltd
 * @package    core_configuration
 */

/**
 * Hook class.
 */
class Hook_config_unzip_cmd
{
    /**
     * Gets the details relating to the config option.
     *
     * @return ?array The details (null: disabled)
     */
    public function get_details()
    {
        return array(
            'human_name' => 'UNZIP_CMD',
            'type' => 'line',
            'category' => 'SERVER',
            'group' => 'ARCHIVES',
            'explanation' => 'CONFIG_OPTION_unzip_cmd',
            'shared_hosting_restricted' => '1',
            'list_options' => '',

            'addon' => 'core_configuration',
        );
    }

    /**
     * Gets the default value for the config option.
     *
     * @return ?string The default value (null: option is disabled)
     */
    public function get_default()
    {
        if (function_exists('zip_open')) {
            return null;
        }
        $params = ' -o @_SRC_@ -x -d @_DST_@';
        if (@is_file('/usr/local/bin/unzip')) {
            return '/usr/local/bin/unzip' . $params;
        }
        if (@is_file('/usr/bin/unzip')) {
            return '/usr/bin/unzip' . $params;
        }
        return 'unzip' . $params;
    }
}
